/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.127 by jmc, Thu Jun 4 23:40:53 2009 UTC revision 1.136 by jmc, Mon Mar 8 16:36:20 2010 UTC
# Line 13  usage() Line 13  usage()
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi-threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-optfile|-of) STRING    list of optfiles to use"
21        echo "  (-addr|-a) STRING        list of email recipients"
22      echo "                             (DEF=\"\" no email is sent)"      echo "                             (DEF=\"\" no email is sent)"
23      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"      echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"
24      echo "                             (DEF=\"../tools/mpack-1.6\")"      echo "                             (DEF=\"../tools/mpack-1.6\")"
25      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"
26      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
27      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
28      echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"      echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"
29      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
30      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"
31      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
32      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
33      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
34      echo "  (-oad)                   perform an OpenAD adjoint run"      echo "  (-oad)                   perform an OpenAD adjoint run"
35      echo "  (-command) STRING        command to run"      echo "  (-command|-c) STRING     command to run"
36      echo "                             (DEF=\"make output.txt\")"      echo "  (-make|-m) STRING        command to use for \"make\""
     echo "  (-m|-make) STRING        command to use for \"make\""  
37      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
38      echo "  (-odir) STRING           used to build output directory name"      echo "  (-odir) STRING           used to build output directory name"
39      echo "                             (DEF=\"hostname\")"      echo "                             (DEF=\"hostname\")"
40      echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"
41      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
42      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43      echo "                             (DEF=\"12\")"      echo "                             (DEF=\"12\")"
44      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46        echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
47        echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
48      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
49      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
50      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
# Line 104  testoutput_var() Line 106  testoutput_var()
106  {  {
107      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
108      #      #
109      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
110      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/results/$reference_output
111      #  using search strings s1 and text label      #  using search strings s1 and text label
112    
# Line 176  testoutput_var() Line 178  testoutput_var()
178          fi          fi
179      fi      fi
180      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
181        
182      return $digits_of_similarity      return $digits_of_similarity
183  }  }
184    
# Line 264  testoutput_run() Line 266  testoutput_run()
266             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
267          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
268             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
269           'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
270           'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
271           'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
272           'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
273           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
274           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
275           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
# Line 291  testoutput_run() Line 293  testoutput_run()
293          done          done
294    
295          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
296          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
297          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
298            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
299            echo $allargs $adNul            echo $allargs $adNul
300          else          else
301            echo $allargs            echo $allargs
302          fi          fi
303  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
304  }  }
305    
# Line 338  genmakemodel() Line 340  genmakemodel()
340              #- run multi-threaded using OpenMP:              #- run multi-threaded using OpenMP:
341                  command="$command -omp"                  command="$command -omp"
342              fi              fi
343                if test "x$USE_R4" = xt ; then
344                    command="$command -use_r4"
345                fi
346              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
347                  command="$command -ts"                  command="$command -ts"
348              fi              fi
349              if test "x$PAPIS" = xt ; then              if test "x$PAPIS" = xt ; then
350                  command="$command -papis"                  command="$command -papis"
351              else              else
352              if test "x$PCLS" = xt ; then              if test "x$PCLS" = xt ; then
353                  command="$command -pcls"                  command="$command -pcls"
354              fi              fi
# Line 444  makemodel() Line 449  makemodel()
449  {  {
450      # makemodel directory      # makemodel directory
451      (      (
452        if test "x$NOMAKE" = xt ; then
453            cd $1;
454            if test -x $EXECUTABLE ; then
455                echo "make skipped!"
456            else
457                echo "no executable!"
458                return 2
459            fi
460        else
461          cd $1;          cd $1;
462          if test -r Makefile ; then          if test -r Makefile ; then
463              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
# Line 463  makemodel() Line 477  makemodel()
477                  tail make.log                  tail make.log
478                  echo failed 1>&2                  echo failed 1>&2
479                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
480                    rm -f $EXECUTABLE
481                  return 1                  return 1
482              else              else
483                  echo successful 1>&2                  echo successful 1>&2
484              fi              fi
485          fi          fi
486        fi
487      )      )
488  }  }
489    
# Line 481  symlink_mpifiles() Line 497  symlink_mpifiles()
497      code_dir=$2      code_dir=$2
498      BUILD_DIR=$dir/$3      BUILD_DIR=$dir/$3
499      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
500        
501      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
502      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
503    
# Line 516  symlink_mpifiles() Line 532  symlink_mpifiles()
532              fi              fi
533          done          done
534      fi      fi
535        
536  }  }
537    
538  linkdata()  linkdata()
# Line 535  linkdata() Line 551  linkdata()
551                  if test "x$MPI" = "xt" ; then                  if test "x$MPI" = "xt" ; then
552                  # mpi test: remove symbolic link & link _mpi sfx file                  # mpi test: remove symbolic link & link _mpi sfx file
553                      if test -h $yy ; then rm -f $yy ; fi                      if test -h $yy ; then rm -f $yy ; fi
554                      if test ! -r $yy ; then                      if test ! -r $yy ; then
555                          ln -sf "../"$1"/"$xx $yy ;                          ln -sf "../"$1"/"$xx $yy ;
556                          printf "$xx " 1>&2                          printf "$xx " 1>&2
557                      fi                      fi
# Line 550  linkdata() Line 566  linkdata()
566                  if test "x$MULTI_THREAD" = "xt" ; then                  if test "x$MULTI_THREAD" = "xt" ; then
567                  # multi-threaded test: remove symbolic link & link eedata.mth                  # multi-threaded test: remove symbolic link & link eedata.mth
568                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
569                      if test ! -r eedata ; then                      if test ! -r eedata ; then
570                          ln -sf "../"$1"/eedata.mth" eedata ;                          ln -sf "../"$1"/eedata.mth" eedata ;
571                          printf 'eedata.mth ' 1>&2                          printf 'eedata.mth ' 1>&2
572                      fi                      fi
# Line 587  runmodel() Line 603  runmodel()
603  {  {
604      # runmodel directory      # runmodel directory
605      #      #
606      #  runs "$COMMAND in "directory"      #  runs "$COMMAND in "directory"
607      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
608      (      (
609          cd $1          cd $1
610          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
611          # make output.txt          # make output.txt
612          echo          echo
613          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test -L $EXECUTABLE ; then
614              if test -x "../"$builddir"/"$EXECUTABLE ; then
615              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
616              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
617              else rm -f $EXECUTABLE
618              fi
619          fi          fi
620          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
621              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
# Line 620  runmodel() Line 639  runmodel()
639                  if test -f $RUNLOG ; then                  if test -f $RUNLOG ; then
640                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
641                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
642                  else                  else
643                      touch $RUNLOG                      touch $RUNLOG
644                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
645                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
# Line 630  runmodel() Line 649  runmodel()
649              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
650          fi          fi
651          rm -f run.log_tmp          rm -f run.log_tmp
         #if test "x$RETVAL" = x0 ; then  
652          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
653              tail $RUNLOG              tail $RUNLOG
654              echo successful 1>&2              echo successful 1>&2
# Line 638  runmodel() Line 656  runmodel()
656              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
657              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
658              return 0              return 0
659            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
660                #-- for some weird cases (run is finihed but with error code)
661                tail $RUNLOG
662                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
663                return 0
664          else          else
665              tail $RUNLOG              tail $RUNLOG
666              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
# Line 692  EOF Line 715  EOF
715          return 0          return 0
716      else      else
717          echo          echo
718          echo "ERROR: failed to compile comparison code -- please specify"          echo "ERROR: failed to compile comparison code -- please specify"
719          echo "  a C compiler using the CC environment variable."          echo "  a C compiler using the CC environment variable."
720          exit 1          exit 1
721      fi      fi
# Line 711  formatresults() Line 734  formatresults()
734      printf '%3s' $listPrt      printf '%3s' $listPrt
735  #   line below does not work on hp-ux_ia64 : do those substitutions later on  #   line below does not work on hp-ux_ia64 : do those substitutions later on
736  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
737        
738      if [ $xx = '..' ]; then      if [ $xx = '..' ]; then
739          printf ' N/O '          printf ' N/O '
740      elif [ $xx = '--' ]; then      elif [ $xx = '--' ]; then
# Line 727  formatresults() Line 750  formatresults()
750      fi      fi
751      printf '  %s' $nm      printf '  %s' $nm
752      printf '\n'      printf '\n'
753        
754  }  }
755    
756  scandirs()  scandirs()
# Line 786  fi Line 809  fi
809  GSL=f  GSL=f
810    
811  CLEANUP=f  CLEANUP=f
812    NORUN=f
813  QUICK=f  QUICK=f
814    NOMAKE=f
815  NOGENMAKE=f  NOGENMAKE=f
816  NOCLEAN=f  NOCLEAN=f
817  NODEPEND=f  NODEPEND=f
# Line 812  MPI=f Line 837  MPI=f
837  MULTI_THREAD=f  MULTI_THREAD=f
838  OUTDIR=  OUTDIR=
839  DELDIR=  DELDIR=
840    USE_R4=
841    
842  ADM=  ADM=
843  OADM=  OADM=
# Line 834  for ac_option ; do Line 860  for ac_option ; do
860      fi      fi
861    
862      ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`      ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
863        
864      case $ac_option in      case $ac_option in
865                    
866          -help | --help | -h | --h)          -help | --help | -h | --h)
# Line 847  for ac_option ; do Line 873  for ac_option ; do
873                    
874          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
875              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
876          -addr=* | --addr=*)          -addr=* | --addr=* | -a=* | --a=*)
877              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
878          -mpackdir | --mpackdir | -mpd | --mpd)          -mpackdir | --mpackdir | -mpd | --mpd)
879              ac_prev=MPACKDIR ;;              ac_prev=MPACKDIR ;;
# Line 856  for ac_option ; do Line 882  for ac_option ; do
882    
883          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
884              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
885          -tdir=* | --tdir=*)          -tdir=* | --tdir=* | -t=* | --t=*)
886              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
887    
888          -skipdir | --skipdir | -skd | --skd)          -skipdir | --skipdir | -skd | --skd)
889              ac_prev=SKIPDIRS ;;              ac_prev=SKIPDIRS ;;
890          -skipdir=* | --skipdir=*)          -skipdir=* | --skipdir=* | -skd=* | --skd=*)
891              SKIPDIRS=$ac_optarg ;;              SKIPDIRS=$ac_optarg ;;
892    
893          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
894              ac_prev=BASH ;;              ac_prev=BASH ;;
895          -bash=* | --bash=*)          -bash=* | --bash=* | -b=* | --b=*)
896              BASH=$ac_optarg ;;              BASH=$ac_optarg ;;
897    
898          -command | --command | -c | --c)          -command | --command | -c | --c)
899              ac_prev=COMMAND ;;              ac_prev=COMMAND ;;
900          -command=* | --command=*)          -command=* | --command=* | -c=* | --c=*)
901              COMMAND=$ac_optarg ;;              COMMAND=$ac_optarg ;;
902    
903          -make | --make | -m | --m)          -make | --make | -m | --m)
904              ac_prev=MAKE ;;              ac_prev=MAKE ;;
905          -make=* | --make=*)          -make=* | --make=* | -m=* | --m=*)
906              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
907    
908          -odir | --odir)          -odir | --odir)
# Line 892  for ac_option ; do Line 918  for ac_option ; do
918          -match | --match ) ac_prev=MATCH_CRIT ;;          -match | --match ) ac_prev=MATCH_CRIT ;;
919          -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;          -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
920    
921          -j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
922          -j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
923    
924          -clean | --clean)          -clean | --clean)
925              CLEANUP=t ; DELDIR=t ;;              CLEANUP=t ; DELDIR=t ;;
926    
927            -norun | --norun | -nr | --nr)
928                NORUN=t ;;
929            -runonly | --runonly | -ro | --ro)
930                QUICK=t ; NOMAKE=t ;;
931          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
932              QUICK=t ;;              QUICK=t ;;
933          -nogenmake | --nogenmake | -ng | --ng)          -nogenmake | --nogenmake | -ng | --ng)
# Line 928  for ac_option ; do Line 958  for ac_option ; do
958    
959          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
960    
961          -ts) TS=t;;          -use_r4|-ur4) USE_R4=t ;;
962    
963            -ts) TS=t;;
964          -papis) PAPIS=t;;          -papis) PAPIS=t;;
   
965          -pcls) PCL=t;;          -pcls) PCL=t;;
966    
967          -*)          -*)
968              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
969              usage              usage
970              ;;              ;;
971            
972          *)          *)
973              echo "Error: unrecognized argument: "$ac_option              echo "Error: unrecognized argument: "$ac_option
974              usage              usage
975              ;;              ;;
976            
977       esac       esac
978        
979  done  done
980    
981  if test "x$QUICK" = xt ; then  if test "x$QUICK" = xt ; then
# Line 988  else Line 1018  else
1018                   LIST=${LIST}" "`ls | grep 'tutorial_'` ;;                   LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
1019          *)       LIST=${LIST}" "$xx ;;          *)       LIST=${LIST}" "$xx ;;
1020        esac        esac
1021      done      done
1022  fi  fi
1023  #echo 'LIST='${LIST}'<'  #echo 'LIST='${LIST}'<'
1024  #- skip dirs, remove duplicate and non-directory:  #- skip dirs, remove duplicate and non-directory:
# Line 1009  do Line 1039  do
1039          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1040          fi          fi
1041      fi      fi
1042  done  done
1043  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1044  #echo 'TESTDIRS='${TESTDIRS}'<'  #echo 'TESTDIRS='${TESTDIRS}'<'
1045    
# Line 1045  else Line 1075  else
1075  fi  fi
1076    
1077  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1078  createcodelet  if test -x tr_cmpnum ; then
1079        echo "skipping comparison code build"
1080    else
1081        createcodelet
1082    fi
1083    
1084  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1085  if test "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
# Line 1117  fi Line 1151  fi
1151  echo  echo
1152  echo >> $SUMMARY  echo >> $SUMMARY
1153  if test "x$ADM" = x -a "x$OADM" = x; then  if test "x$ADM" = x -a "x$OADM" = x; then
1154      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1155      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1156      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
1157         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1158  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
# Line 1142  if test "x$ADM" = x -a "x$OADM" = x; the Line 1176  if test "x$ADM" = x -a "x$OADM" = x; the
1176  else  else
1177      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1178      echo >> $SUMMARY      echo >> $SUMMARY
1179      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1180      then line_0="default     "$MATCH_CRIT ;      then line_0="default     "$MATCH_CRIT ;
1181      else line_0="default    "$MATCH_CRIT ; fi      else line_0="default    "$MATCH_CRIT ; fi
1182      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1183      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
# Line 1157  fi Line 1191  fi
1191    
1192  #  ...and each test directory...  #  ...and each test directory...
1193  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1194        
1195      # set builddir & rundir:      # set builddir & rundir:
1196      builddir="build"      builddir="build"
1197      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
# Line 1172  for dir in $TESTDIRS ; do Line 1206  for dir in $TESTDIRS ; do
1206      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1207          echo -n '  --- dir:' $BUILD_DIR ': '          echo -n '  --- dir:' $BUILD_DIR ': '
1208          makeclean $BUILD_DIR          makeclean $BUILD_DIR
1209            rm -f $BUILD_DIR/$EXECUTABLE
1210          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1211              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1212              run_clean $dir/$rundir              run_clean $dir/$rundir
# Line 1185  for dir in $TESTDIRS ; do Line 1220  for dir in $TESTDIRS ; do
1220          continue          continue
1221      fi      fi
1222    
1223      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1224      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1225      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1226      if test ! -r $fout ; then      if test ! -r $fout ; then
# Line 1213  for dir in $TESTDIRS ; do Line 1248  for dir in $TESTDIRS ; do
1248    
1249      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1250      extra_runs=      extra_runs=
1251      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`      if test "x$NORUN" = xf ; then
1252            ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1253        fi
1254      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1255      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1256          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1257          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1258          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1259          if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1260            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1261              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1262                if test "x$MPI" = "xt" ; then                if test "x$MPI" = "xt" ; then
1263                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
# Line 1242  for dir in $TESTDIRS ; do Line 1279  for dir in $TESTDIRS ; do
1279    
1280      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1281      echo      echo
1282      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1283         echo "Experiment:  $dir"         echo "Experiment:  $dir"
1284      else      else
1285         echo "Experiment:  $dir ; extra_runs=$extra_runs"         echo "Experiment:  $dir ; extra_runs=$extra_runs"
# Line 1255  for dir in $TESTDIRS ; do Line 1292  for dir in $TESTDIRS ; do
1292      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
1293      mkdir $rel_CDIR      mkdir $rel_CDIR
1294      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1295        
1296      if test "x$CLEANUP" = xt ; then      if test "x$NORUN" = xt ; then
1297          echo '====>>> this is to check that we never go through this part <<< ==='              run=N
1298          makeclean $dir/$builddir \          genmakemodel $dir/$builddir && genmake=Y \
1299              && run_clean $dir/$rundir              && makeclean $dir/$builddir \
1300                && run_clean $dir/$rundir \
1301                && symlink_mpifiles $dir $code_dir $builddir \
1302                && makedependmodel $dir/$builddir && makedepend=Y \
1303                && makemodel $dir/$builddir && make=Y
1304      else      else
1305          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1306              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
# Line 1271  for dir in $TESTDIRS ; do Line 1312  for dir in $TESTDIRS ; do
1312              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1313              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1314      fi      fi
1315        
1316        #echo "results='$results'"
1317      echo      echo
1318          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1319          echo          echo
# Line 1327  for dir in $TESTDIRS ; do Line 1369  for dir in $TESTDIRS ; do
1369          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1370              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1371      fi      fi
1372        
1373      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1374        
1375  done  done
1376    
1377  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
# Line 1358  else Line 1400  else
1400              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1401              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1402              echo              echo
1403                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1404                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1405          fi          fi
         test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"  
         test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"  
1406      fi      fi
1407  fi  fi
1408    
1409  rm -f tr_cmpnum.c tr_cmpnum  if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1410        rm -f tr_cmpnum.c tr_cmpnum
1411    fi
1412    
1413  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1414      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'

Legend:
Removed from v.1.127  
changed lines
  Added in v.1.136

  ViewVC Help
Powered by ViewVC 1.1.22